/***************************************************************************
 *   Copyright (C) 2007  Antony Martin <martin.antony@yahoo.fr>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 22 decembre 2006
   derniere modification le 22/09/2007 */

#include <SCE/utils/SCEMath.h>

#define SCE_USE_ID_HACK 0

/* Copyright (C) id software (Quake 3 arena)
   licence : GPL */
float SCE_Math_Sqrt (float number)
{
#if SCE_USE_ID_HACK
    return 1.0F/SCE_Math_InvSqrt (number);
#else
    return pow (number, 0.5F);
#endif
}


float SCE_Math_InvSqrt (float number)
{
#if SCE_USE_ID_HACK
    /* Copyright (C) id software (Quake 3 arena)
       licence : GPL */
    long i;
    float x2, y;
    const float threehalfs = 1.5F;

    x2 = number * 0.5F;
    y  = number;
    i  = * ( long * ) &y;  /* evil floating point bit level hacking */
    i  = 0x5f3759df/*a86*/ - ( i >> 1 ); /* what the fuck? */
    y  = * ( float * ) &i;
    /* 1st iteration */
    y  = y * ( threehalfs - ( x2 * y * y ) );
    /* 2nd iteration, this can be removed */
    y  = y * ( threehalfs - ( x2 * y * y ) );

    return y;
#else
    return 1.0F/pow (number, 0.5F);
#endif
}


/* ajoute le 22/09/2007 */
int SCE_Math_Powi (int x, unsigned int n)
{
    if (n == 0)
        return 1;
    else if (n == 1)
        return x;
    else if (n%2)
        return x * SCE_Math_Powi (x*x, (n-1)/2);
    else
        return SCE_Math_Powi (x*x, n/2);
}

int SCE_Math_PowerOfTwo (int n)
{
    int power = 0;

    while (1)
    {
        if (n % 2)
            break;
        else
        {
            n /= 2;
            power++;
        }
    }

    if (n == 1)
        return power;

    return 0;
}
